//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
//*****                                                                                             *****
//*****   JScript project retrieve_listed_spectra.jsp                                               *****
//*****                                                                                             *****
//*****   MANUAL                                                                                    *****
//*****                                                                                             *****
//*****   Version 3.0 / 25 January, 2009                                                            *****
//*****                                                                                             *****
//*****   Author V.I. Tsanev (vip20@cam.ac.uk)                                                      *****
//*****                                                                                             *****
//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
//*****                                                                                             *****
//***** ALL LINES IN THIS FILE HAVE TO START WITH TWO BACK SLASHES                                  *****
//*****                                                                                             *****
//***** DO NOT MODIFY THIS FILE!!!                                                                  *****
//*****                                                                                             *****
//*******************************************************************************************************
//*******************************************************************************************************
//*****                                                                                             *****
//***** This script project is designed to retrieve set of spectra included in a list file.         *****
//*****      There are a few options for the listed spectra:                                        *****
//*****      (A) Spectra collected with some JSCript projec from the group "short collection" or    *****
//*****          some of the old Jsripts, but but not corrected for dark, offset and stray light.   *****
//*****          This is rather obsolete option. User has to specify a dark spectrum and this       *****
//*****          spectrum will be subtarcted from all other spectra before retrieval. The constant  *****
//*****          multdark can be used to scale dark spectrum if necessary. List file in this case   *****
//*****          has to be created by the JScript project correction_short.jsp                      *****
//*****      (B) Spectra collected with some JSCript projec from the group "collection_short " or   *****
//*****          JSsript project collection_short that are corrected by means of JSsript projects   *****
//*****          correction_short.jsp or correction_long.jsp. List file in this case is created     *****
//*****          by the corresponding correction project.                                           *****
//*****      (C) Spectra collected with some JSCript projec from the group "short collection",      *****
//*****          some of the old Jsripts, or by using OCean OPtics programs OOIBase32 and           *****
//*****          SpectraSuite and then corrected by the program ooWINDc.exe. List file in this      *****
//*****          case is created by this program.                                                   *****
//*****                                                                                             *****
//*****   Requires : (1) A preliminary created and tested fit scanario file .                       *****
//*****              (2) A list file and all listed spectra at the corresponding location           *****
//*****              (3) Dark and background spectra .                                              *****
//*****              (4) Installed Microsoft Excel 2003 or older version. Excel 2007 is not tested  *****
//*****                  and may not respond properly                                               *****
//*****                                                                                             *****
//*****   Outputs  : (1) A result Excel file which comntent is described below                      *****
//*****                                                                                             *****
//*******************************************************************************************************
//*******************************************************************************************************
//*****                                                                                             *****
//*****  This project includes 5 JScrips :                                                          *****
//*****                                                                                             *****
//*****    (1) retrieve_listed_spectra_manual.js                                                    *****
//******       the present file ; it may be excluded from project as it contais only comments,      *****
//*****        i.e. lines starting with two back slashes                                            *****
//*****                                                                                             *****
//*****    (2) retrieve_listed_spectra_initialization.js                                            *****
//*****        the file where user has to input parameters describing collection process            *****
//*****                                                                                             *****
//*****    (3) retrieve_listed_spectra_variables.js                                                 *****
//*****        variables declaration - do not modify this file                                      *****
//*****                                                                                             *****
//*****    (4) retrieve_listed_spectra_action.js                                                    *****
//*****        execution kernel - do not modify this file                                           *****
//*****                                                                                             *****
//*****    (5) retrieve_listed_spectra_functions.js                                                 *****
//*****        collection of functions used - do not modify this file                               *****
//*****                                                                                             *****
//*****  The default position of the project and all assotiated files is the folder                 *****
//*****        c:\work\scripts\retrieval\ .                                                         *****
//*****                                                                                             *****
//*******************************************************************************************************
//*******************************************************************************************************
//*****                                                                                             *****
//***** The user has to initialize of the project by modifying input in JSripts file                *****
//*****     retrieve_listed_spectra_initialization.js                                               *****
//*****                                                                                             *****
//*****    ( 1) Name of the list file. It's default position is in the folder c:\work\ooi\.         *****
//*****         File name is a string, i.e. a word in quotation marks                               *****
//*****         var infile                                                                          *****
//*****                                                                                             *****
//*****    ( 2) Name of an existing fit scanario including full path. It is recommended to have     *****
//*****         a folder for each used spectrometer and keep there corresponding convolved          *****
//*****         absorption cross sections and fit scanarios. The full file name is a string,        *****
//*****         i.e. a word in quotation marks                                                      *****
//*****         var fitscenario                                                                     *****
//*****                                                                                             *****
//*****    ( 3) Number of references included in the fit sceanrio - integer                         *****
//*****         var NumberReferences                                                                *****
//*****                                                                                             *****
//*****    ( 4) Number of control or main reference - integer.  It's concentration will be          *****
//*****         evaluated in units of molecules per squared centimeter and ppm*m (at 1013 mbar      *****
//*****         and 20 degree C)                                                                    *****
//*****         var ControlReference                                                                *****
//*****                                                                                             *****
//*****    ( 5) The formula of the control or main referenece - string, i.e. a word in quotation    *****
//*****         marks                                                                               *****
//*****         var ControlReferenceName                                                            *****
//*****                                                                                             *****
//*****    ( 6) The common shift limits for all referneces as entered in fit scenario.              *****
//*****         Shift is a string, i.e. a word in quotation marks.                                  *****
//*****         At the moment it is not possible to access these values by the scripts. Inputs      *****
//*****         may be "-5 < - > +5" or "unlimited"                                                 *****
//*****         var ShiftLimits                                                                     *****
//*****                                                                                             *****
//*****    ( 7) The common squeeze limits for all referneces as entered as entered in fit           *****
//*****         scenario. Squeeze is a string, i.e. a word in quotation marks.                      *****
//*****         At the moment it is not possible to access these values by the scripts. Inputs      *****
//*****         may be ""0.97 < - > 1.03"" or "unlimited"                                           *****
//*****         var SqueezeLimits                                                                   *****
//*****                                                                                             *****
//*****    ( 8) Name of the result excel file. It's default position is in the folder c:\work\ooi\. *****
//*****         File name is a string, i.e. a word in quotation marks. Do not add extension.        *****
//*****         var excelfile                                                                       *****
//*****                                                                                             *****
//*****    ( 9) Spectrometer type. Permitted options are "USB2000", "USB2000+" and "USB4000".       *****
//*****         Spectrometer type is a string, i.e. a word in quotation marks                       *****
//*****         var spectrometerTYPE                                                                *****
//*****                                                                                             *****
//*****    (10) Spectrometer ID (serial number). Spectrometer ID is a string, i.e. a word in        *****
//*****         quotation marks                                                                     *****
//*****         var spectrometerID                                                                  *****
//*****                                                                                             *****
//*****    (11) Dark corrent spectrum full name (including path). File name is a string, i.e. a     *****
//*****         word in quotation marks. This is an obsolete input. In case you performed           *****
//*****         correction with JScript projects correction_short.jsp or correction_long.jsp        *****
//*****         or program ooWINDc.exe you still have to inpute file name of an existing file.      *****
//*****         var dark                                                                            *****
//*****                                                                                             *****
//*****    (12) A constant used to scale dark current spectrum. This is an obsolete input.          *****
//*****         In case you performrd correction with script projects correction_short.jsp or       *****
//*****         correction_long.jsp or program ooWINDc.exe you have to input a zero value,          *****
//*****         program ooWINDc.exe a harmfull spectrum subtarction.                                *****
//*****         var var multDARK                                                                    *****
//*****                                                                                             *****
//*****    (13) Background spectrum full name (including path). File name is a string,              *****
//*****         i.e. a word in quotation marks. This is an obsolete input. In case you performrd    *****
//*****         correction with script projects correction_short.jsp or correction_long.jsp         *****
//*****         you still have to inpute file name of an existing file.                             *****
//*****         var background                                                                      *****
//*****                                                                                             *****
//*****    (14) Delay after some actions permiting to observe better retrieval process - integer.   *****
//*****         var wait                                                                            *****
//*****                                                                                             *****
//*******************************************************************************************************
//*******************************************************************************************************
//*****                                                                                             *****
//***** NOTE:  The user has to type inputs only in file retrieval_initializattion.js                *****
//*****        in lines not ending with five starts (*****)                                         *****
//*****                                                                                             *****
//*******************************************************************************************************
//*******************************************************************************************************
//*****                                                                                             *****
//***** The structure of the list files is as follows:                                              *****
//*****                                                                                             *****
//*****                  178                                     - number of spectra in the list    *****
//*****                                                            count starts with zero, i.e.     *****
//*****                                                            this list includes 179 files     *****
//*****                  150                                     - individual IT                    *****
//*****                  5                                       - number of co-added spectra       *****
//*****                  lab                                     - location ID                      *****
//*****                  testing the script                      - experiment ID                    *****
//*****                  vip20                                   - Autors ID                        *****
//*****                  0 C:\work\ooi\tutu00000\tutu00000.std   - first spectrum in the list       *****
//*****                  .....................................                                      *****
//*****                  178 C:\work\ooi\tutu00000\tutu00178.std - last spectrum in the list        *****
//*****                                                                                             *****
//*******************************************************************************************************
//*******************************************************************************************************
//*****                                                                                             *****
//***** The content of the outpot Excel file is as follows :                                        *****
//*****                                                                                             *****
//***** The two leftmost column of the output excel file present an extensive protocol of the       *****
//*****     performrd retrieval. This protocol is given below :                                     *****
//*****                                                                                             *****
//*****		Start date							11/12/200                                           *****
//*****		End date							11/12/200                                           *****
//*****		Start time							13:59:56                                            *****
//*****		End time							14:36:58                                            *****
//*****		Experiment description				NO2 over London                                     *****
//*****		Location description				Regent park TV tower                                *****
//*****		Author ID							Isla                                                *****
//*****			                                                                                    *****
//*****		Individual integration time (ms)	449                                                 *****
//*****		Number of accumulations				40                                                  *****
//*****		Number of averages	                1                                                   *****
//*****		Total integration time (s)			17.96                                               *****
//*****                                                                                             *****
//*****     Spectrometer type                   USB2000                                             *****
//*****     Spectrometer S/N                    USB2G11107                                          *****
//*****			                                                                                    *****
//*****		List file							1                                                   *****
//*****		Number of listed spectra			84                                                  *****
//*****			                                                                                    *****
//*****		Dark spectrum						c:\work\ooi\bgnd2.spe                               *****
//*****		Dark spectrum multiplied by 		0                                                   *****
//*****		Background spectrum					c:\work\ooi\bgnd2.spe                               *****
//*****			                                                                                    *****
//*****		Low math limit						530                                                 *****
//*****		High math limit						1449                                                *****
//*****			                                                                                    *****
//*****		Fit Scenario file					C:\work\USB2G11107\isla_1.fs                        *****
//*****			                                                                                    *****
//*****		Low Fit Range						630                                                 *****
//*****		High Fit Range						1349                                                *****
//*****			                                                                                    *****
//*****		DOAS Polynomial Degree				3                                                   *****
//*****		Offset Polynomial Degree			-1                                                  *****
//*****			                                                                                    *****
//*****		Fit Reference Spectrum #  0			isla Ring bgnd                                      *****
//*****		Fit Reference Spectrum #  1			SO2 scia 293K Geq=0.45nm                            *****
//*****		Fit Reference Spectrum #  2			O3 Bre G=0.45nm 223K                                *****
//*****		Fit Reference Spectrum #  3			NO2 Van G=0.45nm Tony                               *****
//*****		Fit Reference Spectrum #  4			O4 Bre 296K G=0.45nm                                *****
//*****		Fit Reference Spectrum #  5			HONO Stutz G=0.45nm 296K                            *****
//*****			                                                                                    *****
//*****		Common shift limits					-5 < - > +5                                         *****
//*****		Common squeeze limits				0.97 < - > 1.03                                     *****
//*****                                                                                             *****
//*****	 The next columns of the output excel file contain retrieval results as follows :           *****
//*****                                                                                             *****
//*****		Spectrum              - full spectrm name                                               *****
//*****		Number                - number in the list file (0, 1, 2...)                            *****
//*****		Time                  - spectrum registartion end time (hh:mm:ss)                       *****
//*****		NO2 CA molec/cm^2     - column amount of control or main referenece in units            *****
//*****                             molecules per squared centimeter                                *****
//*****		NO2 CA ppm * m        - column amount of control or main referenece in units ppm*m      *****
//*****                             caloculated at 1013 mbar and 20 degree C                        *****
//*****		NO2 CA error ppm * m  - error of the calculated column amount of control or main        *****
//*****                             referenece in units ppm*m                                       *****
//*****		NO2 shift             - shift applied during the fit of of control or main referenece   *****
//*****		NO2 squeeze           - squeeze applied during the fit of of control or main referenece *****
//*****		Chi                   - chi squared                                                     *****
//*****		                                                                                        *****
//***** The next four colums are repeated for each reference included in the fit                    *****
//*****                                                                                             *****
//*****		Ref0 CA               - column amount in units molecules per squared centimeter         *****
//*****		Ref0 CA error         - column amount error in units molecules per squared centimeter   *****
//*****		Ref0 shift            - shift appleied when fitting particular reference                *****
//*****		Ref0 squeeze          - squeeze appleied when fitting particular reference              *****
//*****                                                                                             *****
//*******************************************************************************************************
//*******************************************************************************************************
//*****                                                                                             *****
//***** Version history                                                                             *****
//*****                                                                                             *****
//***** v. 2.0  - added results for all refereneces included in the fit scenario                    *****
//*****                                                                                             *****
//***** v. 3.0  - imp[roved content of two leftmost column of the output excel file                 *****
//*****         - math limits are calculated automatically depending on fit limits                  *****
//*****                                                                                             *****
//*******************************************************************************************************
//*******************************************************************************************************
//*****                                                                                             *****
//***** Known bugs:                                                                                 *****
//*****                                                                                             *****
//*****             - To open ther results Excel file user has to invoke Excel by                   *****
//*****               Start -> Programs -> Microsoft Office -> Excel                                *****
//*****                                                                                             *****
//*****                                                                                             *****
//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************

